part of xwidgetbase;

class XItem extends StatelessWidget {
  final dynamic item;
  final Function? onTap;
  final Function? onPressed;
  final String? labelPeriodo;
  final Color? colorcard;
  final Color? colorLabelPeriodo;
  final List<Widget>? children;
  final TextStyle? labelStyle;
  final bool visibleBottomBorderOfCard;
  final bool labelPeriodoOnTop;
  final TextAlign labelPeriodoTextAlign;
  final CrossAxisAlignment? childrensCrossAxisAlignment;
  final BoxConstraints? constraints;
  final MainAxisAlignment? mainAxisAlignmentlabelPeriodo;
  final AlignmentGeometry? alignmentLabelPeriodoOnTop;
  final CrossAxisAlignment? crossAxisAlignmentLabelPeriodoOnTop;
  double labelPeriodoWidth;
  double? labelPeriodoHeight;
  AlignmentGeometry? labelPeriodoAlignOnLeft;
  final Widget? labelPeriodoWidget;
  final Color? colorBackGroungTitleContainer;
  final double? widthBorderOfTitleContainer;
  XItem({
    Key? key,
    this.item,
    this.onTap,
    this.alignmentLabelPeriodoOnTop,
    this.labelPeriodoWidget,
    this.crossAxisAlignmentLabelPeriodoOnTop,
    this.colorcard,
    this.labelStyle,
    this.labelPeriodoAlignOnLeft,
    this.mainAxisAlignmentlabelPeriodo,
    this.visibleBottomBorderOfCard = false,
    this.colorLabelPeriodo,
    this.onPressed,
    this.labelPeriodo = "",
    this.labelPeriodoWidth = 150,
    this.labelPeriodoHeight,
    this.children,
    this.childrensCrossAxisAlignment,
    this.labelPeriodoOnTop = false,
    this.labelPeriodoTextAlign = TextAlign.center,
    this.colorBackGroungTitleContainer,
    this.widthBorderOfTitleContainer,
    double? width,
    double? height,
    BoxConstraints? constraints,
  })  : constraints = (width != null || height != null) ? constraints?.tighten(width: width, height: height) ?? BoxConstraints.tightFor(width: width, height: height) : constraints,
        super(key: key);
  @override
  Widget build(BuildContext context) {
    //var size = MediaQuery.of(context).size.height;

    return GestureDetector(
        onTap: onTap as void Function()?,
        //  Container(
        child: ConstrainedBox(
          constraints: constraints ?? BoxConstraints(),
          child: Container(
            child: Card(
              color: colorcard ?? Colors.transparent,
              //height: size /3, //senza questo crasha tutto, è l'unico che da la size all'item senza forzarlo!!!!!!
              child: Container(
                  decoration: visibleBottomBorderOfCard == true ? BoxDecoration(border: Border(bottom: BorderSide(width: 6, color: Colors.blue.withOpacity(0.5)))) : null,
                  child: Column(
                    crossAxisAlignment: crossAxisAlignmentLabelPeriodoOnTop ?? CrossAxisAlignment.center,
                    children: [
                      !labelPeriodoOnTop || labelPeriodo == null
                          ? Container()
                          : Container(
                              alignment: alignmentLabelPeriodoOnTop ?? Alignment.center,
                              width: labelPeriodoWidth,
                              height: labelPeriodoHeight,
                              padding: EdgeInsets.symmetric(vertical: 2),
                              color: colorBackGroungTitleContainer != null ? null : colorLabelPeriodo ?? Colors.transparent,
                              margin: EdgeInsets.fromLTRB(0, 0, 0, 0),
                              // height: height,
                              decoration: colorBackGroungTitleContainer != null
                                  ? BoxDecoration(
                                      color: colorLabelPeriodo ?? Colors.transparent,
                                      border: Border(
                                        top: BorderSide(color: colorBackGroungTitleContainer ?? colorLabelPeriodo ?? Colors.transparent, width: widthBorderOfTitleContainer ?? 2),
                                        left: BorderSide(color: colorBackGroungTitleContainer ?? colorLabelPeriodo ?? Colors.transparent, width: widthBorderOfTitleContainer ?? 2),
                                        right: BorderSide(color: colorBackGroungTitleContainer ?? colorLabelPeriodo ?? Colors.transparent, width: widthBorderOfTitleContainer ?? 2),
                                      ))
                                  : null,
                              child: labelPeriodo!.isNotEmpty
                                  ? Container(
                                      // height: labelPeriodoHeight,
                                      child: Text(
                                        labelPeriodo!,
                                        // overflow: TextOverflow.clip,
                                        textAlign: labelPeriodoTextAlign, //TextAlign.center,
                                        style: labelStyle ?? XStyles.xStyTextForLabel(),
                                      ),
                                    )
                                  : Container(),
                            ),
                      Row(children: [
                        labelPeriodoOnTop || labelPeriodo == null
                            ? Container()
                            : Container(
                                alignment: labelPeriodoAlignOnLeft ?? Alignment.center,
                                width: labelPeriodoWidth,
                                height: labelPeriodoHeight,
                                // height: size,
                                padding: EdgeInsets.symmetric(vertical: 2),
                                color: colorLabelPeriodo ?? Colors.transparent,

                                margin: EdgeInsets.fromLTRB(0, 0, 0, 0),
                                // height: height,
                                child: labelPeriodo!.isNotEmpty
                                    ? labelPeriodoWidget ??
                                        Container(
                                          // height: labelPeriodoHeight,
                                          child: Text(
                                            labelPeriodo!,
                                            textAlign: labelPeriodoTextAlign, //TextAlign.center,
                                            style: labelStyle ?? XStyles.xStyTextForLabel(),
                                          ),
                                        )
                                    : Container(),
                              ),
                        Expanded(
                          // color: Colors.white,
                          child: Row(children: [
                            Expanded(
                              child: Wrap(
                                  crossAxisAlignment: WrapCrossAlignment.center,
                                  spacing: 5,
                                  runSpacing: 5,
                                  // crossAxisAlignment: childrensCrossAxisAlignment ??
                                  //     CrossAxisAlignment.start,
                                  children: children!),
                            ),
                          ]),
                        ),
                      ]),
                    ],
                  )),
            ),
          ),
        ));
  }
}
